<template>
  <router-link :to="`/project/${project.ref.value.id}`">
    <div class="main">
      <ProjectScreenshot :project="project" class="py-2 px-5"/>

      <div class="separation-border"></div>

      <div class="info">
        <div>
          <span
            v-if="projectNameIsEmpty"
            class="ada-project-no-name"
          >
            no name
          </span>
          <span v-else class="info-name">
            {{ project.data.name }}
          </span>
          <span class="ml-6 info-id">
            {{ project.data.id }}
          </span>
          <span class="ml-6 info-user">
            by {{ user.data.name }}
          </span>
          <span
            :title="lastModifiedLocalShort"
            class="ml-6 info-date"
          >
            {{ lastModifiedLocalShort }}
          </span>
          <p class="info-abstract">
            {{ project.data.abstract }}
          </p>
        </div>
        <div
          v-if="isCurrentUser && project.data.showcase"
          class="info-showcase-layout"
        >
          <p class="info-showcase-display">showcase</p>
        </div>
      </div>
    </div>
  </router-link>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import ProjectScreenshot from '../components/ProjectScreenshot.vue'
import { useUser, useStore } from '../store'
import { getProjectLastModification } from '../storage'
import { getLocalDate } from '../utils'

export default {
  props: {
    project: {
      type: Object,
      required: true
    }
  },
  components: {
    ProjectScreenshot
  },
  setup (props) {
    const { user } = useUser(props.project.data.owner.id)
    const { idIsCurrentUser } = useStore()
    const isCurrentUser = computed(() => idIsCurrentUser(user.id))
    const projectNameIsEmpty = computed(() => (
      props.project.data.name === undefined ||
      props.project.data.name.trim().length === 0
    ))

    const lastModified = ref(null)
    onMounted(async () => {
      lastModified.value = await getProjectLastModification(props.project.data)
    })
    const lastModifiedLocal = computed(
      () => lastModified.value ? getLocalDate(lastModified.value) : ''
    )
    const lastModifiedLocalShort = computed(
      () => lastModifiedLocal.value !== '' ? lastModifiedLocal.value.format('MMM, D YYYY') : ''
    )

    return {
      user,
      isCurrentUser,
      projectNameIsEmpty,
      lastModifiedLocal,
      lastModifiedLocalShort
    }
  }
}
</script>

<style lang="postcss" scoped>
.main {
  @apply bg-white;
  @apply dark:bg-gray-800;
  @apply border border-gray-100 rounded-sm;
  @apply dark:border-gray-700;
  @apply shadow-lg;
  @apply dark:shadow-xl dark:shadow-gray-900;
  @apply mx-auto;
  @apply flex flex-col;
  @apply w-92.5;
}

.main:hover {
  @apply shadow-xl;
  @apply dark:shadow-lg dark:shadow-gray-700;
  @apply border-purple-200;
  @apply dark:border-gray-700;
}

.separation-border {
  @apply border-t border-purple-100;
  @apply dark:border-purple-900;
}

.info {
  @apply pt-3 px-5 h-48;
  @apply flex flex-col justify-between;
  @apply overflow-auto;
}

.info::-webkit-scrollbar {
  @apply w-4;
}

.info::-webkit-scrollbar-track {
  @apply bg-white;
  @apply dark:bg-gray-800;
}

.info::-webkit-scrollbar-thumb {
  @apply bg-gray-400;
  @apply dark:bg-gray-400;
  @apply border-solid border-4 border-white;
  @apply dark:border-gray-800;
  @apply rounded-xl;
}

.info-name {
  @apply text-xl text-gray-900;
  @apply dark:text-gray-300;
  @apply leading-tight;
}

.info-id {
  @apply text-xs text-gray-400;
  @apply dark:text-gray-600;
  @apply leading-normal;
}

.info-user {
  @apply mt-3;
  @apply text-base text-gray-600;
  @apply dark:text-gray-400;
  @apply leading-normal;
}

.info-date {
  @apply text-xs text-gray-400;
  @apply dark:text-gray-600;
  @apply leading-normal;
}

.info-abstract {
  @apply mt-3;
  @apply whitespace-pre-wrap;
  @apply text-sm text-gray-900;
  @apply dark:text-gray-300;
  @apply leading-normal;
}

.info-showcase-layout {
  @apply bg-white;
  @apply dark:bg-gray-800;
  @apply bottom-0;
  @apply sticky;
}

.info-showcase-display {
  @apply text-center text-gray-400;
  @apply dark:text-gray-600;
  @apply z-10;
}
</style>